import java.util.concurrent._

// Pravljenje niti
//
// Da bismo napravili nit potrebno je da definisemo klasu koja nasledjuje klasu Thread 
// i implementiramo metod run cije izvrsavanje pocinje kada nad instancom nase klase 
// pozovemo metod start.
//
// Drugi nacin je da nasa klasa implementira interfejs Runnable 
// i implementira metod run.
// Medjutim, da bismo naglasili da zelimo da se metod run nase instance izvrsava kao posebna nit
// potrebno je da napravimo instancu tipa Thread kojoj u konstruktoru treba da prosledimo instancu nase klase
// (koja implementira metod run.
//

class Konobar(ime : String, brStolova : Int) extends Thread {
  override def run(){
    for(i <- 0 until brStolova){
//    Klasa ThreadLocalRandom predstavlja generator slucajnih brojeva 
//    jedinstven na nivou jedne niti.
//    Metod current() vraca objekat ove klase za trenutnu nit.
      Thread.sleep(ThreadLocalRandom.current().nextInt(1,10)*1000)
      println("Konobar " + ime + " je usluzio " + i + ". sto.")
    }
    println("Konobar " + ime + " je zavrsio sa posluzivanjem.")
  }
}

object Restoran {
   def main(args : Array[String]) {
//   Pravimo instance niti  
     val stefan = new Konobar("Stefan", 10)
     val nikola = new Konobar("Nikola", 10)
     val filip = new Konobar("Filip", 10)   
     val nebojsa = new Konobar("Nebojsa", 10) 
     val djordje = new Konobar("Djordje", 10) 
     
//   Ukoliko nasa klasa implementira interfejs Runnable 
//     
//   val stefan = new Thread(new Konobar("Stefan", 10))
     
//   Metod start zapocinje izvrsavanje metoda run
     stefan.start()
     nikola.start()
     filip.start()
     nebojsa.start()
     djordje.start()
   }
}